@[Link("onigmo")]
@[Link(ldflags: "#{__DIR__}/onigmo/onigwrap.o")]

lib Onigmo
  type Regex = Pointer(Void)
  type Region = Pointer(Void)

  fun create = onigwrap_create(pattern : LibC::Char*, len : UInt32,
                               ignoreCase : Int32,
                               multiline : Int32,
                               dotall : Int32,
                               anchored : Int32) : Regex
  fun free = onigwrap_free(re : Regex)
  fun region_free = onigwrap_region_free(region : Region)

  fun search = onigwrap_search(re : Regex, str : LibC::Char*, offset : UInt32, length : UInt32) : Region
  fun num_regs = onigwrap_num_regs(region : Region) : Int32
  fun pos = onigwrap_pos(region : Region, index : Int32) : Int32
  fun len = onigwrap_len(region : Region, index : Int32) : Int32
end

pattern = "a"
str = "# foobar"

re = Onigmo.create(pattern, pattern.size, false, true, false, false)
region = Onigmo.search(re, str.to_unsafe, 0, str.bytesize)
num_regs = Onigmo.num_regs(region)
(0...num_regs).each do |i|
  pos = Onigmo.pos(region, i)
  len = Onigmo.len(region, i)
  puts "match #{i}: #{str[pos, len]}"
end
Onigmo.region_free(region)
Onigmo.free(re)
